! fs2uc10extern.f: external functions used by fs2uc10.f program
!
! David Barnes, October 2006
!
! $Id: fs2uc10extern.f90,v 1.3 2007/04/04 22:58:45 dbarnes Exp $
!
!
      SUBROUTINE INITCALLBACK()
      INTEGER I
      REAL X1, X2, Y1, Y2, Z1, Z2
!
      REAL X(10), Y(10), Z(10)
      INTEGER SELECTED(10)
      COMMON /CNUM/ X, Y, Z, SELECTED
      SAVE /CNUM/
!      
!     determine the world bounds
      call s2qwin(X1,X2,Y1,Y2,Z1,Z2)
!     
!     create randomly jittering dots
      DO 20 I=1,10
         X(I) = X1 + RAND(0) * (X2 - X1)
         Y(I) = Y1 + RAND(0) * (Y2 - Y1)
         Z(I) = Z1 + RAND(0) * (Z2 - Z1)
 20   CONTINUE
      RETURN
      END
!
!
!
      SUBROUTINE NEWCALLBACK(T, IC)
      REAL*8 T
      INTEGER IC
      INTEGER I
      REAL X1, X2, Y1, Y2, Z1, Z2
      REAL*8 PX(3), COL(3), HILITE(3)
!
      REAL X(10), Y(10), Z(10)
      INTEGER SELECTED(10)
      COMMON /CNUM/ X, Y, Z, SELECTED
      SAVE /CNUM/
!      
!     determine the world bounds
      call s2qwin(X1,X2,Y1,Y2,Z1,Z2)
!     
!     jitter the points
      DO 30 I=1,10
         X(I) = X(I) + (RAND(0) - 0.5) * (X2 - X1) / 133.
         Y(I) = Y(I) + (RAND(0) - 0.5) * (Y2 - Y1) / 133.
         Z(I) = Z(I) + (RAND(0) - 0.5) * (Z2 - Z1) / 133.
 30   CONTINUE
!     
!     draw the points
      call s2sci(4)
      call s2slw(2.)
      call s2pt(10, X, Y, Z, 1)
!
!     attach handles
      
      COL(1) = 0.99
      COL(2) = 0.05
      COL(3) = 0.05
      HILITE(1) = 0.99
      HILITE(2) = 0.99
      HILITE(3) = 0.05
      DO 40 I=1,10
         PX(1) = X(I)
         PX(2) = Y(I)
         PX(3) = Z(I)
         call cs2ah(PX, 0.33, COL, HILITE, I, SELECTED(I))
 40   CONTINUE
      RETURN
      END
!
!
!
      SUBROUTINE PICKCB(ID)
!
      REAL X(10), Y(10), Z(10)
      INTEGER SELECTED(10)
      COMMON /CNUM/ X, Y, Z, SELECTED
      SAVE /CNUM/
!      
      IF (SELECTED(ID).EQ.0) THEN
         SELECTED(ID) = 1
      ELSE
         SELECTED(ID) = 0
      ENDIF
      call cs2th(ID)
      RETURN
      END
!
