#include <stdio.h>
#include <stdlib.h>
#include "s2plot.h"

int main(int argc, char *argv[])
{
   float x = 0, 				/* Position */
         y = 0,
         z = 0;
   float rx = 0.4,				/* Right vector */
	 ry = 0.3,
	 rz = 0.2;
   float ux = 0.2,				/* Up vector */
         uy = 0.8,
         uz = -0.6;
   float r = 1.0,				/* Colour */
         g = 0.0,
	 b = 0.4;
   char *text = "S2PLOT is great!";

   s2opend("/?",argc, argv);			/* Open the display */
   s2swin(-10.,10., -10.,10., -10.,10.);	/* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);	/* Draw coordinate box */

   ns2text(x,y,z, rx,ry,rz, ux,uy,uz, r,g,b, text);
						/* Display some text */
   s2show(1);					/* Open the s2plot window */
   
   return 1;
}
