#include <stdio.h>
#include <stdlib.h>
#include "s2plot.h"

int main(int argc, char *argv[])
{
   int nseg  = 32;				/* Segments for circle */
   float asp = 1.0;				/* Circle not ellipse */
   float r = 0.5;

   s2opend("/?",argc, argv);			/* Open the display */
   s2swin(-1.,1., -1.,1., -1.,1.);		/* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);	/* Draw coordinate box */
   s2sci(S2_PG_RED);
   s2circxy(0.0,0.0,-0.5, r, nseg,asp);		/* Circle in x-y plane */
   s2sci(S2_PG_BLUE);
   s2circxy(0.0,0.0,+0.5, r/2.0, nseg,asp);	/* Circle in x-y plane */
   s2show(1);					/* Open the s2plot window */
   
   return 1;
}
