#include <stdio.h>
#include <stdlib.h>
#include "s2plot.h"

int main(int argc, char *argv[])
{
   float x = 0.0;				/* Text location */
   float y = 0.0;
   float z = 0.0; 
   int N = 4;					/* Number of strings */
   int i;					/* Loop variable */
   float height;				/* Height of text */
   char string[32];				/* String of text */

   s2opend("/?",argc, argv);			/* Open the display */
   s2swin(-1.,1., -1.,1., -1.,1.);		/* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);	/* Draw coordinate box */

   for (i=0;i<N;i++) {
      s2sci((i%15)+1);				/* Set the colour */
      height = (i+1)*0.3;			
      sprintf(string,"Height = %.1f\n",height);	/* Create the string */
      x = drand48()*1.6 - 0.8;			/* Random text location */
      y = drand48()*1.6 - 0.8;
      z = drand48()*1.6 - 0.8;
      s2sch(height);			/* Set text height */
      s2textxy(x,y,z,string);			/* Write some text in x-y plane */
   }

   s2show(1);					/* Open the s2plot window */
   
   return 1;
}
