#include <stdio.h>
#include <stdlib.h>
#include "s2plot.h"

int main(int argc, char *argv[])
{
   float r, g, b; 				/* Background colour */
   XYZ xyz = { 0.0, 0.0, 0.0 };			/* Position */
   COLOUR col;					/* Sphere colour */ 
   float radius = 0.3;				/* Radius */

   s2opend("/?",argc, argv);			/* Open the display */

   r = 0.3; 					/* Background colour */
   g = 0.7;
   b = 0.2;
   ss2sbc(r, g, b);				/* Set background colour */
   ss2sfc(1.0-r, 1.0-g, 1.0-b);			/* Set foreground colour */

   s2swin(-1.,1., -1.,1., -1.,1.);		/* Set the window coordinates */
   s2box("BCDET",0,0,"BCDET",0,0,"BCDET",0,0);	/* Draw coordinate box */

   col.r = 0.5;					/* Sphere colour */
   col.g = 0.5;					/* Sphere colour */
   col.b = 0.5;					/* Sphere colour */
   ns2vsphere(xyz, radius, col);		/* Draw the sphere */
   s2textxy(0.0, 0.5, 0.5, "Press 'd' or 'F1'");	/* Write some text */

   s2show(1);					/* Open the s2plot window */
   
   return 1;
}
