! fs2uc11extern.f: external functions used by fs2uc11.f program
!
! David Barnes, October 2006
!
! $Id: fs2uc11extern.f90,v 1.1 2006/10/19 05:41:10 dbarnes Exp $
!
      REAL FUNCTION FX(U,V)
      REAL U,V
      INCLUDE 'fs2uc11.inc'
      FX = R2*COS(V) * COS(U) + R1 * COS(U) * (1. + AMP * cos(U * NTW))
      RETURN
      END
!
      REAL FUNCTION FY(U,V)
      REAL U,V
      INCLUDE 'fs2uc11.inc'
      FY = R2 * SIN(V) + AMP * SIN(U * NTW)
      RETURN
      END
!
      REAL FUNCTION FZ(U,V)
      REAL U,V
      INCLUDE 'fs2uc11.inc'
      FZ = R2*COS(V) * SIN(U) + R1 * SIN(U) * (1. + AMP * cos(U * NTW))
      RETURN
      END
!
      REAL FUNCTION FCOL(U,V)
      REAL U,V
      INCLUDE 'fs2uc11.inc'
      FCOL = 0.5 + SIN(0.5 * U) * AMP * SIN(V)
      RETURN
      END
